import javax.microedition.lcdui.*;
import java.util.*;

public class ElementList extends List implements CommandListener { 
 midlet midlet;
 Displayable parent;
 Hashtable items;

 ElementList (String title, Hashtable items, midlet midlet, Displayable parent) { 
  super (title + " ("+items.size()+")", IMPLICIT);
  this.items = items;
  this.midlet = midlet;
  this.parent = parent;
  for (Enumeration e = items.keys() ; e.hasMoreElements() ; )  {
   append ((String)e.nextElement(),null);
  }
  setCommandListener (this);
  addCommand(midlet.SEARCH_CMD);
  if (parent == null) { addCommand(midlet.QUIT_CMD); } 
  else { addCommand(midlet.BACK_CMD); }
  Display.getDisplay(midlet).setCurrent(this);
 }

 public void commandAction(Command c, Displayable d) {
  if (c == midlet.SEARCH_CMD) { 
   new SearchBox (items, midlet, this);
  } 
  else if (c == midlet.BACK_CMD) { 
   Display.getDisplay(midlet).setCurrent(parent);
  } 
  else if (c == midlet.QUIT_CMD) { 
   midlet.quit();
  } 
  else { 
   new ElementForm (getString(getSelectedIndex()), midlet, this);
  }
 }

}