import javax.microedition.lcdui.*;
import java.util.*;

public class SearchBox extends Form implements CommandListener { 
 midlet  midlet;
 Displayable parent;
 Hashtable items;
 TextField text;
 ChoiceGroup ext;
 static boolean extended=false;

 SearchBox (Hashtable items, midlet midlet, Displayable parent) {
  super (Settings.SearchHdr);
  this.items = items;
  this.parent = parent;
  this.midlet = midlet;
  setCommandListener(this);
  addCommand(midlet.SEARCH_CMD);
  addCommand(midlet.BACK_CMD);
  text=new TextField (Settings.SearchFieldHdr, "", 30, TextField.ANY);
  append (text);
  ext=new ChoiceGroup ("",ChoiceGroup.MULTIPLE);
  ext.append (Settings.ExtendedSearch,null);
  append (ext);
  ext.setSelectedIndex (0, extended);
  Display.getDisplay(midlet).setCurrent(this);
 }

 public void commandAction(Command c, Displayable d) {    
  extended=ext.isSelected(0);
  if (c == midlet.SEARCH_CMD) {
   new ElementList(Settings.FoundHdr, search(items,text.getString()), midlet, this);
  } 
  else { 
   Display.getDisplay(midlet).setCurrent(parent);
  }
 }

 public static String upperStr =
  "ABWGDEVZIJKLMNOPRSTUFHCQYXŨ";
 public static String lowerStr =
  "abwgdevzijklmnoprstufhcqyx";
 public String toUpperCase(String in) {
  String out="";
  char c; 
  int n,l=in.length();
  for (int i=0; i<l; i++) {
   c=in.charAt (i);
   n=lowerStr.indexOf(c);
   if (n>-1) out+=upperStr.charAt(n);
   else out+=c;
  }
  return out;
 }

 public Hashtable search (Hashtable items, String pattern) {
  Hashtable result = new Hashtable();
  pattern = toUpperCase(pattern.trim());
  String key, value;
  int n=items.size (),i=0,p=0;
  for (Enumeration e = items.keys() ; e.hasMoreElements() ; )  {
   key=(String)e.nextElement();
   value=(String)items.get (key);
   if (toUpperCase(key).indexOf(pattern)>-1 || 
       extended==true && toUpperCase(value).indexOf(pattern)>-1)
    result.put (key, value);
   i++;
   if (i%10==0) {
    if ((i*100)/n>p) {
     p=(i*100)/n;
     setTitle (Settings.SearchHdr+p+"%");
    }
   }
  }
  setTitle (Settings.SearchHdr);
  return result;
 }

}